#!/bin/bash

ISUMA_STORE="/var/isuma/media/"
ISUMA_SOURCE="ISUMA_CONTENT/"
ISUMA_HOST="isuma.tv"
PHPLOC="`dirname $0`/../sync/"

echo $PHPLOC

#TODO: Turn on indicator light

#A little hack to run all the following commands in the background
#If we don't do this, udev will get stuck
for i in "1"
do

    #make sure we can reach isuma
    #waits 20s, since our link may suck
    #TODO: Might want to tune this to better suit real-world conditions
    #ping $ISUMA_HOST -c 5 -w 20

    if [ $? -ne 0 ]
    then
        echo "Could not ping " $ISUMA_HOST >> usb.out
        exit
    fi

    echo "Mounting device " $1 >> usb.out

    mkdir -p /mnt/$1


    #Need to sync in both directions, so mount read/write
    mount -orw /dev/$1 /mnt/$1

    #If the specially named content directory exists
    #copy files to/from it as necessary

    if [ -d "/mnt/$1/$ISUMA_SOURCE" ]
    then
        #Scenario 1: Files are on the external
        #drive, but not the internal one.
        #Copy them to the local HDD
        echo "Isuma content found on $1 . Copying to local hard drive." >> usb.out 
        OLD_IFS=$IFS
        COPIED=`rsync -r --partial -t "/mnt/$1/$ISUMA_SOURCE/" "$ISUMA_STORE"`
        #TODO: Change to individual rsync commands for each file
        #so that a failure won't prevent rest of files from
        #copying

        #Removed queue dependence because we can't guarantee network access during sync
        #   for c in $COPIED
        #   do
        #      $PHPLOC/removefromqueue.php download $c
        #    done

        #Scenario 2: Content is on the internal drive
        #that needs to be uploaded to server (IE said
        #files are listed in the upload queue).
        #In actuality, we just sync everything new and
        #let the cron jobs sort it out
        rsync -r --partial -t "$ISUMA_STORE/" "/mnt/$1/$ISUMA_SOURCE"
        #    CHECK_FILES="/mnt/$1/$ISUMA_SOURCE/"
        #    for f in $CHECK_FILES
        #    do
        #      if $PHPLOC/isinqueue.php upload $f
        #      then
        #        rsync --ignore-existing "$ISUMA_STORE/$f" "/mnt/$1/$ISUMA_SOURCE/$f"
        #        #If it copied OK, remove from upload queue
        #        if [ $? -eq 0 ]
        #        then
        #          $PHPLOC/removefromqueue.php upload $f
        #        fi
        #      fi
        #   done

        IFS=$OLD_IFS
    fi

    #TODO: Turn off indicator light
    umount "/mnt/$1"

    #delay to simulate long copy operation
    #remove in production
    #sleep 3600
done&

echo "Mount script exiting" >> usb.out
