#!/usr/bin/php
<?

/* Quick hack to check if a large number of files in the download queue are present on
   the hard drive at once and move them to the "file" queue of they are.
   It's faster to do it like this because spinning up a new Drupal instance each
   time you check for one file takes several seconds.

   Specifically, this script downloads the first n files in the queue,
   uses file_exists to make sure it's on the local HDD, and if so adds it to a list.
   Then it moves the contents of that list to the files queue.

*/

include "transfer.inc";


//TODO: Change 5 to 200 after we confirm this works
$queue = getqueue( XMLRPC_SERVER, "download", 0, 5 );

foreach( $queue as $file ){

  $filename = ISUMA_ROOT . DIRECTORY_SEPARATOR . 
    "media" . DIRECTORY_SEPARATOR . 
    $file["filetype"] . DIRECTORY_SEPARATOR .
    $file["fileoption"] . DIRECTORY_SEPARATOR .
    $file["filepath"];

  if( file_exists( $filename ) ){
    if(DEBUG){
      trigger_error( $filename . " exists!", E_USER_NOTICE );
    }
    $existingfiles[] = $file;

  }else{
    if(DEBUG){
      trigger_error( $filename . " does not exist!", E_USER_WARNING );
    }
  }
}

groupmovetoqueue( XMLRPC_SERVER, "download", "file", $existingfiles );

?>
