#!/usr/bin/php
<?

define( 'DEFAULT_BANDWIDTH', 0 ); # in kbps 0 for none

#Script to poll the download queue for the latest file
#and download it to the local server via wget.

#Just a wrapper, all the heavy lifting is done in transfer.inc.

#Change to the directory we are running from so we properly include other files
chdir( dirname( $_SERVER['SCRIPT_FILENAME'] ) );

include "transfer.inc";
include "error.inc";

//$source = "tunnel@isumacs.koumbit.net:/home/tunnel/media/";
$source = null;
$destination = ISUMA_ROOT . "/media/";
$queuename = "download";

// get the lockfile early so that network errors below will not stack up
acquire_lockfile() or trigger_error( "Lockfile creation failed. Held by another process.", E_USER_ERROR );

//Get download rate limit from server and choose a reasonable default if not present
$configs = getconfig( XMLRPC_SERVER );

$rate = $configs['download_bandwidth'];

if( !isset( $rate ) || !is_numeric( $rate ) ){
  if( DEBUG) {
    trigger_error( "Download rate limit not specified or not a number. Defaulting to " . DEFAULT_BANDWITH . "KB/s.", E_USER_WARNING );
  }
  $rate = DEFAULT_BANDWIDTH;
}else{
  if( DEBUG ){
    trigger_error( "Got download rate limit of " . $rate . "KB/s from server.", E_USER_NOTICE );
  }
}

#delete all files corresponding to unpublished nodes
#so we don't have any accidental name conflicts
deleteunpublished( XMLRPC_SERVER, $destination, "file" );

#Set source to null since the library fetches it with getamazonurl
queuetransfer( XMLRPC_SERVER, $source, $destination, $queuename, $rate, "http" );

exit_successfully();
