<?php

/**
 * backwards-compatibility convenience funtion
 */
function acquire_lockfile() {
  // XXX: this should be in /var/run/isuma, not /var/isuma/run
  return linux_procfs_lock(ISUMA_ROOT . "/run/" . basename( $_SERVER["SCRIPT_FILENAME"]));
}

/**
 * create a lockfile atomically with /proc
 *
 * modified from http://php.net/manual/en/function.getmypid.php#112782
 */
function linux_procfs_lock($lockfile) {
  // the @ in front of 'symlink' is to suppress the NOTICE you get if the LOCK_FILE exists
  if (@symlink("/proc/" . getmypid(), $lockfile) !== FALSE) {
    register_shutdown_function('unlock', $lockfile);
    return true;
  }
  // link already exists
  // check if it's stale
  if (is_link($lockfile) && !is_dir($lockfile)) {
    // XXX: there's still a race condition here: some process could be
    // doing the same thing at the same time
    if (unlink($lockfile)) {
      // try to lock again
      return linux_procfs_lock();
    }
    // if we can't remove the lockfile, don't try again because we'll
    // get in an infinite loop
  }

  return false;
}

/**
 * simple unlock function
 *
 * this just removes the lockfile
 */
function unlock($lockfile) {
  return unlink($lockfile);
}
