#!/usr/bin/php
<?

#Inform the central server of our IP configuration.
#Usage: setconfig.php [LAN_IP] [backend] [WAN_IP] [SSH_PORT]

#Change to the directory we are running from so we properly include other files
chdir( dirname( $_SERVER['SCRIPT_FILENAME'] ) );

include "transfer.inc";

/*if( $argc < 3 ){
  print "Usage: setconfig.php [LAN_IP] [backend] [WAN_IP]\n";
  exit;
}*/

//For some reason I can't use constants inside a call to exec,
//so load the constant into a local variable
$if = LAN_INTERFACE;


//If the lan IP has been specified on the command line, use it.
//Otherwise, call ifconfig to get the lan IP.
//We have to do this because we don't have the IP in the $_SERVER
//superglobal when running from the command line, unfortunately.
if( $argc >= 2 ){
  $lanip = $argv[1];
}else{
  $lanip = trim( exec( "/sbin/ifconfig $if | grep 'inet addr' ", $lines, $retcode ) );
  $lanip = preg_replace( "/^.*inet addr:(.*) Bcast.*$/", "$1", $lanip );
  //If the above ifconfig command failed, just set the lan IP to Null.
  //TODO: Should this maybe abort execution totally? The central server
  //can't do anything useful if we don't have the lan IP.
  //Right now we just warn but this could be changed to E_USER_ERROR
  //to cause the script to quit
  if( $retcode != 0 ){
    if( DEBUG > 0 ){
      trigger_error( "Could not get IP address. ifconfig returned " . $retcode, E_USER_WARNING );
    }
    $lanip = Null;
  }
}

//If the backend type was specified on the command line, use it.
//Otherwise, default to local_server because this script usually runs on one.
if( $argc >= 3 ){
  $backend = $argv[2];
}else{
  $backend = "local_server";
}

//If a WAN IP was specified on the command line, use it.
//Otherwise, send Null which means the central server will detect
//our IP automatically. This is the preferred behavour.
if( $argc >= 4 ){
  $wanip = $argv[3];
}else{
  $wanip = Null;
}

if( $argc >= 5 ){
  $ssh_port = $argv[4];
}else{
  $ssh_port = file_get_contents("/etc/isuma-autossh/port");
}

$response = setconfig( XMLRPC_SERVER, $wanip, $lanip, $backend, $ssh_port);

if( DEBUG > 0 ){
  trigger_error( print_r( $response, true ) );
}
?>
