<?

include "config.inc"; # That should be in download... or bootstrap.inc
include "lock.inc"; # That should be in download... or bootstrap.inc

include_once( "../transcoding/transcode.inc" );
require_once('XML/RPC.php');

define(TIMEOUT, 30);

#TODO: addtoqueue and removefromqueue are nearly identical.
#Refactor them into a single function maybe.
function movetoqueue( $server, $fromqueue, $toqueue, $filename, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array( 
      new XML_RPC_Value( $fromqueue, "string"),
      new XML_RPC_Value( $toqueue, "string"),
      new XML_RPC_Value( $filename, "string"), 
      new XML_RPC_Value( $filetype, "string" ), 
      new XML_RPC_Value( $fileoption, "string" )
  );
  
  $message = new XML_RPC_Message( 'cs.movetoqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  if( DEBUG != 0 ){
    trigger_error( XML_RPC_decode( $response->value() ) . "\n", E_USER_NOTICE );
  }
}

/* Quick hack to let us move multiple files at once */
function groupmovetoqueue( $server, $fromqueue, $toqueue, $files ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }

  $targets = array();

  foreach( $files as $file ){
    $target = new XML_RPC_Value( array (
      "filepath" => new XML_RPC_Value( $file["filepath"], "string" ),
      "filetype" => new XML_RPC_Value( $file["filetype"], "string" ),
      "fileoption" => new XML_RPC_Value( $file["fileoption"], "string" )
    ), "struct" );
    
    $targets[] = $target;   

  }

  $params = array(
    new XML_RPC_Value( $fromqueue, "string" ),
    new XML_RPC_Value( $toqueue, "string" ),
    new XML_RPC_Value( $targets , "array" )
  );


  $message = new XML_RPC_Message( 'cs.groupmovetoqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  if( DEBUG != 0 ){
    trigger_error( XML_RPC_decode( $response->value() ) . "\n", E_USER_NOTICE );
  }  

}

#TODO: addtoqueue and removefromqueue are nearly identical.
#Refactor them into a single function maybe.
function addtoqueue( $server, $queuename, $filename, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array( 
      new XML_RPC_Value( $queuename, "string"),
      new XML_RPC_Value( $filename, "string"), 
      new XML_RPC_Value( $filetype, "string" ), 
      new XML_RPC_Value( $fileoption, "string" )
  );
  
  $message = new XML_RPC_Message( 'cs.addtoqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $message = XML_RPC_decode( $response->value() ) . "\n";


  if( DEBUG != 0 ){
    trigger_error( var_export($message, TRUE), E_USER_NOTICE );
  }

  return( $message );

}


function removefromqueue( $server, $queuename, $filename, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array( 
      new XML_RPC_Value( $queuename, "string"), 
      new XML_RPC_Value( $filename, "string"), 
      new XML_RPC_Value( $filetype, "string" ), 
      new XML_RPC_Value( $fileoption, "string" )
  );

  $message = new XML_RPC_Message( 'cs.removefromqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  if( DEBUG != 0 ){
    trigger_error( XML_RPC_decode( $response->value() ), E_USER_NOTICE );
  }

}

#Get list of files in a given queue
#Optional search criteria in $search as key/value pairs
function searchqueue( $server, $queuename, $search = null, $offset = 0, $limit = 5 ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array(
      new XML_RPC_Value( $queuename, "string" ),
      new XML_RPC_Value( $offset, "int" ),
      new XML_RPC_Value( $limit, "int" ),
      $search
  );
  $message = new XML_RPC_Message( 'cs.getqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);
  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $queue = XML_RPC_decode( $response->value() );

  if( DEBUG != 0 ){
    trigger_error( "Downloaded " . count( $queue ) . " items.", E_USER_NOTICE );
  }

  if( DEBUG > 1 ){
    trigger_error( print_r( $queue, true ), E_USER_NOTICE );
  }

  return( $queue );

}

#Get only published files in a queue
function getqueue( $server, $queuename, $offset = 0, $limit = 5 ){
  $search = new XML_RPC_Value( array(
        "status" => new XML_RPC_Value( 1, "int" )
  ), "struct" );
  return searchqueue( $server, $queuename, $search, $offset, $limit );

}

#Get only unpublished files in a queue
function getunpublished( $server, $queuename ){
  $search = new XML_RPC_Value( array(
        "status" => new XML_RPC_Value( 0, "int" )
  ), "struct" );
  return searchqueue( $server, $queuename, $search );

}


#check if a file is in a queue
function isinqueue( $server, $queuename, $filename, $filetype, $fileoptions ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array( 
      new XML_RPC_Value( $queuename, "string" ),
      new XML_RPC_Value( array(
        "filepath" => new XML_RPC_Value( $filename, "string"), 
        "filetype" => new XML_RPC_Value( $filetype, "string" ), 
        "fileoption" => new XML_RPC_Value( $fileoptions, "string" )
        ), "struct"
        
      )
  );
  $message = new XML_RPC_Message( 'cs.fileinqueue', $params );

  $response = $centralserver->send($message, TIMEOUT);
  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $queue = XML_RPC_decode( $response->value() );

  if( DEBUG != 0 ){
    trigger_error( "Downloaded " . count( $queue ) . " items.", E_USER_NOTICE );
  }

  if( DEBUG > 1 ){
    trigger_error( print_r( $queue, true ), E_USER_NOTICE );
  }

  return( $queue );


}

/**
 * Get a file from the head of a queue, and transfer it from 
 * $source to $destination. $transport is one of "rsync" or "http"
 * Currently, HTTP can only be used to download files, not upload
 * them.
 *
 * @param $server The URL of the XMLRPC endpoint.
 * @param $source The local or remote file to copy from, 
 *   or null to use a generated amazon URL. Remote file can
 *   be rsync or http URL.
 * @param $destination The local or remote location to copy to.
 *   Do not include the file name, just the directory.
 *   Remote files can only be rsync.
 * @param $queuename The central server queue to get file names from
 * @param $speedlimit Limit upload/download speed to this number, in KB/sec
 * @param $transport THE type of connection to use, rsync or http.
 * @return nothing.
 *   
 */

function queuetransfer( $server, $source, $destination, $queuename, $speedlimit = DEFAULT_BANDWITH, $transport = "rsync" ){
  $queue = getqueue( $server, $queuename, 0, 1 );

  #If we get a good reply that is an empty list, exit
  if( count( $queue ) == 0 ){
    if( DEBUG != 0 ){
      trigger_error( "No items in queue. Exiting.", E_USER_NOTICE );
    }
    exit();
  }

  $filepath = $queue[0]['filepath'];
  $filetype = $queue[0]['filetype'];
  $fileoption = $queue[0]['fileoption'];

  # If we are confured to upload/download on a different interface,
  # make sure said interface is up and can access the internet
  $sync_ip="";
  if( defined('SYNC_INTERFACE') && SYNC_INTERFACE != LAN_INTERFACE ){
    exec( "ping -c 4 -I " . SYNC_INTERFACE . " " . "www.isuma.tv" , $lines, $return );
    if( $return == 0 ){
      if( DEBUG ){
        trigger_error( "Isuma.tv reachable on " . SYNC_INTERFACE . ". Using it for file sync.", E_USER_NOTICE );
      }
      $sync_ip = get_ip( SYNC_INTERFACE );
    }else{
      if( DEBUG ){
        trigger_error( "Unable to reach isuma.tv on " . SYNC_INTERFACE . ". Falling back to " . LAN_INTERFACE . ".", E_USER_NOTICE );
      }
      $sync_ip = get_ip( LAN_INTERFACE );
    }

  }else{
    if( DEBUG ){
      trigger_error( "Sync and LAN using same interface, " . LAN_INTERFACE . ".", E_USER_NOTICE );
    }
    $sync_ip = get_ip( LAN_INTERFACE );
  }


  if( DEBUG != 0 ){
    trigger_error( "Starting rsync for file " . $filepath, E_USER_NOTICE ) ;
  }

  #transfer the file using rsync
  if( $transport == "rsync" ){
    $filename = $filetype . DIRECTORY_SEPARATOR . $fileoption . DIRECTORY_SEPARATOR . $filepath;
    $rate_limit = ($speedlimit == 0) ? "" : "--bwlimit=$speedlimit";
    system( "rsync -R -e \"ssh -i " . ISUMA_ROOT . DIRECTORY_SEPARATOR . ".id_rsa -b $sync_ip\" $rate_limit --partial-dir=" . escapeshellarg( $destination . "/.incomplete" ) . " " . escapeshellarg( $source . DIRECTORY_SEPARATOR . "." . DIRECTORY_SEPARATOR . $filename ) . " " . escapeshellarg( $destination . DIRECTORY_SEPARATOR ) , $result );
  #If we're using HTTP instead of rsync, we might be wanting to pull the file
  #from Amazon. Get the amazon URL in that case.
  }else if( $transport == "http" ){
    if( $source == Null ){
      $source = getamazonurl( XMLRPC_SERVER, $filepath, $filetype, $fileoption );
      $filename = ''; # silence out warnings
    }else{
      //TODO: Figure out what should really happen here.
      //We don't have a use case for this, where you would pass in a source URL and it
      //appends /type/options/name but it seems like a reasonable default
      $filename = $filetype . DIRECTORY_SEPARATOR . $fileoption . DIRECTORY_SEPARATOR . $filepath;
      $source = $source . DIRECTORY_SEPARATOR . $filename;
    }
    $destination = $destination . DIRECTORY_SEPARATOR . $filetype .  DIRECTORY_SEPARATOR . $fileoption;
#only retry once because failed downloads get retried again by this script
    $rate_limit = ($speedlimit == 0) ? "" : "--limit-rate=$speedlimit" . "k";
    system( "wget -t 1 --bind-address=$sync_ip $rate_limit -c " . escapeshellarg( $source  ) . " -P " . escapeshellarg( $destination . DIRECTORY_SEPARATOR . $filename ) , $result );
  }else{
    trigger_error( "Invalid transport type " . $transport . ".", E_USER_ERROR );
  }

  #if the transfer succeeds, move it to the "file" queue.
  #if it failed, leave it in the queue and exit.
  if( $result == 0 ){
    if( DEBUG != 0 ){
      trigger_error( "Transfer of " . $filepath . " succeeded!", E_USER_NOTICE );
    }

    movetoqueue( $server, $queuename, "file", $filepath, $filetype, $fileoption );
    //If we are uploading a raw file, and it's no longer in upload or transcode
    //queues, delete it
    if( $fileoption == "raw" && cleanup( $server, $filepath, $filetype, $fileoption ) ){
      if( DEBUG ){
        trigger_error( "Deleting file " . $filepath . " because it is done uploading and transcoding.", E_USER_NOTICE );
      }

      unlink( $source . DIRECTORY_SEPARATOR . $filename );
      removefromqueue( $server, "file",  $filepath, $filetype, $fileoption );
    }

    #if there's no fault code, success! we are done.
    exit();
  }else{
    if( defined('DOWNLOAD_FAILURE') && DOWNLOAD_FAILURE == 'after' ){
      trigger_error( "Transfer failed. Moving to end of queue to retry later.", E_USER_WARNING );
      removefromqueue( $server, $queuename, $filepath, $filetype, $fileoption );
      createfilenode( $server, $filepath, $filetype, $fileoption );
      addtoqueue( $server, $queuename, $filepath, $filetype, $fileoption );
    }else if( defined('DOWNLOAD_FAILURE') && DOWNLOAD_FAILURE == 'delete' ){
      trigger_error( "Transfer failed. Removing from queue.", E_USER_WARNING );
      removefromqueue( $server, $queuename, $filepath, $filetype, $fileoption );
    }else{
      trigger_error( "Transfer failed. Retrying immediately.", E_USER_WARNING );
    }
    trigger_error( "Transfer of " . $filepath . " failed with exit code " . $result . ".", E_USER_ERROR );
  }

}

#Ask the central server to reserve a unique filename for a new file node.
#Prevents name collisions.
function reservefilename( $server, $nid, $filepath, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array(
      new XML_RPC_Value( $nid, "int" ),
      new XML_RPC_Value( $filepath, "string" ),
      new XML_RPC_Value( $filetype, "string" ),
      new XML_RPC_Value( $fileoption, "string" )
      );
  $message = new XML_RPC_Message( 'cs.reservefilename', $params );

  $response = $centralserver->send($message, TIMEOUT);
  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $newfilename = XML_RPC_decode( $response->value() );

  if( DEBUG != 0 ){
    trigger_error( $filepath . " reserved " . $newfilename . " as a new filename\n", E_USER_NOTICE );
  }

  return $newfilename;

}

#Add a file to download queues for all local servers.
function addfile( $server, $filepath, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $params = array(
      new XML_RPC_Value( $filepath, "string" ),
      new XML_RPC_Value( $filetype, "string" ),
      new XML_RPC_Value( $fileoption, "string" )
      );
  $message = new XML_RPC_Message( 'cs.add', $params );

  $response = $centralserver->send($message, TIMEOUT);
  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $message = XML_RPC_decode( $response->value() );

  if( DEBUG != 0 ){
    trigger_error( var_export($message, TRUE), E_USER_NOTICE );
  }

  return $message;

}

#Get the ip info for a local server.
function getconfig( $server ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }
  $message = new XML_RPC_Message( 'cs.getconfig', null );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $message = XML_RPC_decode( $response->value() );

  if( DEBUG != 0 ){
    trigger_error( var_export($message, TRUE), E_USER_NOTICE );
  }

  return $message;  

}

#send our IP information to the central server.
function setconfig( $server, $wanip, $lanip, $backend, $ssh ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }

  $params = array(
      new XML_RPC_Value( array(
          "wan_address" => new XML_RPC_Value( $wanip, "string" ),
          "lan_address" => new XML_RPC_Value( $lanip, "string" ),
          "backend" => new XML_RPC_Value( $backend, "string" ),
          "ssh_port" => new XML_RPC_Value( $ssh, "int" ) )
        , "struct" )
      );


  $message = new XML_RPC_Message( 'cs.setconfig', $params );

  $response = $centralserver-> send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $message = XML_RPC_decode( $response->value() );

  return $message;

}

/**
 * Get the URL of a given piece of media (video, picture, etc) that
 * points to it on Amazon AWS.
 *
 * @param $server The XMLRPC endpoint URL.
 * @param $name the nsame of the file
 * @param $type The type of the file according to the CS/ video, text, etc.
 * @param $option Subtype. Exampled include hi, lo, pod.
 */
function getamazonurl( $server, $name, $type, $option ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }

  $params = array(
        new XML_RPC_Value( $name, "string"), 
        new XML_RPC_Value( $type, "string" ), 
        new XML_RPC_Value( $option, "string" )
  );

  $message = new XML_RPC_Message( 'cs.amazonurl', $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $message = XML_RPC_decode( $response->value() );

  return $message;

}

/**
 * Ask the central server if a file is safe to delete.
 * Used only on raw files, it returns false if the
 * file is in either (or both) of the transcode or upload
 * queues. It returns true if the file is in neither of the
 * queues and is therefore safe to delete.
 * It also unpublishes the node.
 *
 * @param $filename The name of the file to check (name only, no path)
 * @param $filetype Media type, generally video
 * @param $fileoption The media subtype. Currently only accepts "raw"
 * @return True if the file is safe to delete, false otherwise
 *
 */
function cleanup( $server, $filename, $filetype, $fileoption ){
  if( $fileoption != "raw" ){
    trigger_error( "Only raw files can be cleaned. Option " . $fileoption . " files cannot.", E_USER_ERROR );
  }
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);
  $params = array(
      new XML_RPC_Value( $filename, "string" ),
      new XML_RPC_Value( $filetype, "string" ),
      new XML_RPC_Value( $fileoption, "string" )
  );

  $message = new XML_RPC_Message( "cs.cleanup", $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $reply = XML_RPC_decode( $response->value() );
  if( DEBUG ){
      trigger_error( "(" . $filename . "," . $filetype . "," . $fileoption . ") is " . ( ($reply)?"":"not " ) . "safe to delete.", E_USER_NOTICE );
  }

  return $reply;

}


function transcode_to( $source, $destination,  $format ){
  switch( $format ){
    case "ipod":
      return ls_isuma_ipod( $source, $destination );
      break;
    case "high":
      return ls_isuma_video_hi( $source, $destination );
      break;
    case "low":
      return ls_isuma_video_lo( $source, $destination );
      break;
    case "hd":
      return ls_isuma_video_hd( $source, $destination );
      break;
    default:
      trigger_error( "Unknown video format " . $format . ".", E_USER_ERROR );
      break;

  }

}



/**
 * Get the most recent file to be transcoded, and transcode it
 * to high bandwidth, low bandwidth and iPod formats.
 *
 * @param $server the XMLRPC server hosting the transfer queue
 * @param $source the directory in which to find files to transcode
 * @param $destination the directory in which to place transcoded files
 *
 * Note that the $dir/$type/$option directory structure will be used
 * so don't add $type or $option to the source or destination dirs.
 */

function transcode( $server, $source, $destination, $queuename ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);

  if( DEBUG > 1 ){
    $centralserver->debug = 1;
  }

  $queue = getqueue( $server, $queuename );

  #If we get a good reply that is an empty list, exit
  if( count( $queue ) == 0 ){
    if( DEBUG != 0 ){
      trigger_error( "No items in queue. Exiting.", E_USER_NOTICE );
    }
    exit();
  }

  $filepath = $queue[0]['filepath'];
  $filetype = $queue[0]['filetype'];
  $fileoption = $queue[0]['fileoption'];

  #Transcode to each of the 3 video types
  #TODO: Make this more general instead of using hardcoded consants
  $source = $source . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR . $fileoption . DIRECTORY_SEPARATOR . $filepath;

  if( !file_exists( $source ) ){
    removefromqueue( $server, "transcode", $filepath, $filetype, $fileoption );
    trigger_error( "Source for $source missing! Removed from queue.", E_USER_ERROR );
  }
  #Each video we transcode has a different fileoption so we don't add that to destination string yet
  $destination = $destination . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR;

  //TODO: This combined with transcode_to is just an advanced for/case. Make it make sense.
  //TODO: $flag and the values for $format don't do anything. Get rid of the values
  //and operate properly on the result of the transcode.
  $extensions = array( "ipod" => "mp4", "high" => "flv" );
  //List of completed files so we know what to delete if a transcode fails
  $completed = array();
  foreach( $extensions as $format => $extension ){
    //For various queue operations below, we need to know the filename
    //that the transcoded file *will have* after it is done transcoding.
    $outfile = ls_replace_file_extension( $filepath, $extension );

    $finaldestination = $destination . $format ;
    if( !is_dir( $finaldestination ) ){
      trigger_error( "Creating directory " . $finaldestination, E_USER_NOTICE );
      umask( 0002 ); 
      mkdir( $finaldestination, 0775, true );
    }
    if( DEBUG ){
      trigger_error( "Starting transcode of " . $source . " to " . $format  . " format.", E_USER_NOTICE );
    }

    //Check if we've already transcoded to this format.
    //For example, if a transcode to one format finished but the next format 
    //was interrupted, we want to skip the already-completed file
    //and restart the incomplete transcode.

    if( isinqueue( $server, "file", $outfile, $filetype, $format ) ){
      trigger_error( "File ($outfile, $filetype, $format) was already transcoded! Skipping.", E_USER_NOTICE );
      continue;
    }

    $newfileloc = transcode_to( $source, $finaldestination, $format );
    if( DEBUG ){
      trigger_error("Transcode returned: $newfileloc", E_USER_NOTICE );
    }
    $newfile = basename( $newfileloc );
    //If we get this fake file name, this is an HD transcode on a non-HD
    //video. Do nothing.
    if( $newfile == "QsvZXZOf4xW2qdQvyFYx.flv" ){
      if( DEBUG ){
        trigger_error( "This file, $filepath, is not HD-quality. Skipping addtoqueue.", E_USER_NOTICE );
      }
    //If the transcode succeeds, add said transcoded file to the files queue
    }else if( $newfileloc !== False ){
      if( DEBUG ){
        trigger_error( "Transcode of " . $source . " to " . $format . " format succeeded. Adding to file queue.", E_USER_NOTICE );
      }
      createfilenode( $server, $newfile, $filetype, $format );
      addtoqueue( $server, "file", $newfile, $filetype, $format );
      //Keep track for successful files so we can delete then if
      //a later transcode fails
      $completed[] = array( $newfile, $filetype, $format, $newfileloc );
      if( DEBUG ){
        print_r( $completed );
      }
    }else{
      if( DEBUG ){
        print_r( $completed );
      }
      //delete and remove from file queue previous, successful transcodes if any
      removefromqueue( $server, $queuename, $filepath, $filetype, $fileoption );
      removefromqueue( $server, "upload", $filepath, $filetype, $fileoption );
      foreach( $completed as $badfile ){
        if( DEBUG ){
          trigger_error( "Removing ($badfile[0], $badfile[1], $badfile[2]) from file queue and deleting $badfile[3]", E_USER_NOTICE );
        }
        removefromqueue( $server, "file", $badfile[0], $badfile[1], $badfile[2] );
        unlink( $badfile[3] );
      }
      unlink( $source );
      unlink( $finaldestination . DIRECTORY_SEPARATOR . $newfile );
      trigger_error( "Transcoding to " . $format . " format of " . $source . " failed.", E_USER_ERROR );

    }
  }

  //When we are done transcoding, get it out of the transcode queue
  movetoqueue( $server, $queuename, "file", $filepath, $filetype, $fileoption );

  if( cleanup( $server, $filepath, $filetype, $fileoption ) ){
    if( DEBUG ){
      trigger_error( "Deleting file " . $source . " because it is done uploading and transcoding.", E_USER_NOTICE );
    }
    #delete the file, and also remove it from the file queue since it's been deleted!
    unlink( $source );
    removefromqueue( $server, "file", $filepath, $filetype, $fileoption );
  }
}

/**
 * Create a file node on the central server. This node represents a file
 * that may be transferred to or from the local server or are just
 * there.
 *
 * @param $server the URL of the xmlrpc api to the central server
 * @param $filename File name, without any directory path
 * @param $filetpye The type of media (video, picture, etc)
 * @param $fileoption Media subtype (ipod, high, low, etc)
 * @return The Node ID (NID) of the file node (whether created or existing)
 *
 */

function createfilenode( $server, $filename, $filetype, $fileoption ){
  preg_match('@^(?:http://)?(?:([^:]*):([^\@]*)\@)?([^/]+)(/.*)$@i', $server, $matches);
  $centralserver = new XML_RPC_Client( $matches[4], $matches[3] );
  $centralserver->setCredentials($matches[1], $matches[2]);

  $params = array( new XML_RPC_Value( array(
    "filepath" => new XML_RPC_Value( $filename, "string"), 
    "filetype" => new XML_RPC_Value( $filetype, "string" ), 
    "fileoption" => new XML_RPC_Value( $fileoption, "string" )
    ), "struct"
  ) );

  $message = new XML_RPC_Message( "cs.createfilenode", $params );

  $response = $centralserver->send($message, TIMEOUT);

  if ( !$response ) {
    trigger_error( "XMLRPC Error: " . $centralserver->errstr, E_USER_ERROR);
  }
  elseif( $response->faultcode() ){
    trigger_error( "XMLRPC Error: " . $response->faultstring(), E_USER_ERROR );
  }

  $reply = XML_RPC_decode( $response->value() );
  if( DEBUG ){
    trigger_error( "Node ID for ($filename, $filetype, $fileoption) is " . $reply["nid"] . ".", E_USER_NOTICE );
  }
  return $reply;

}

/**
 * Go through a location on the filesystem and delete all files 
 * corresponding to unpublished nodes which reside there
 *
 * @param $server The URL of the XMLRPC server the holds the queue
 * @param location The location on the hard drive to check
 */
function deleteunpublished( $server, $location, $queue ){
  $unpublished = getunpublished( $server, $queue );
  foreach( $unpublished as $file ){
    $filepath = $file['filepath'];
    $filetype = $file['filetype'];
    $fileoption = $file['fileoption'];

    if( DEBUG ){
      trigger_error( "Deleting unpublished file $filetype/$fileoption/$filepath .", E_USER_NOTICE );
    }

    if( file_exists( $location . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR . $fileoption . DIRECTORY_SEPARATOR . $filepath ) ){
      unlink( $location . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR . $fileoption . DIRECTORY_SEPARATOR . $filepath );
    }
    removefromqueue( $server, $queue, $filepath, $filetype, $fileoption );

  }
}





function get_ip( $if ){
  $lanip = trim( exec( "/sbin/ifconfig $if | grep 'inet addr' ", $lines, $retcode ) );
  $lanip = preg_replace( "/^.*inet addr:(.*) Bcast.*$/", "$1", $lanip );
  return $lanip;

}

?>
