<?php

/* This script handles files uploaded to the local servers.
   They are POSTed here from the isuma.tv site,
   whereupon they are renamed to a unique name asigned by the
   central server, and then added to this server's upload queue.
   */

include "transfer.inc";

$filetype = "video";

$fileoption = "raw";

$nid = $_POST['context'];

/* Fill in the type and option fields with reasonable defaults
   for testing uploads
   We also use "raw" in produciton as the type for a newly uploaded video
   */

if( $filetype == "" ){
  $filetype = "video";
}
if( $fileoption =="" ){
  $fileoption = "raw";
}

  if( count(  $_FILES['upload_file'] ) < 1 ){
    exit();
  }

#If we make it here, a file was uploaded. Get its new file name from the
#central server, and move it to that location.

#first, delete any unpublished files in file queue
#to pevent name collisions
deleteunpublished( XMLRPC_SERVER, ISUMA_ROOT . DIRECTORY_SEPARATOR . "media", "file" );

$origfilename = $_FILES['upload_file']['name'];

$tmpname =  $_FILES['upload_file']['tmp_name'];

#Get new filename from central server using reservefilename

$destfilename = reservefilename( XMLRPC_SERVER, $nid, 'artcovideo.mov', $filetype, $fileoption );
$destfiledir = ISUMA_ROOT . DIRECTORY_SEPARATOR . "media" . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR . $fileoption;
$destfilepath = $destfiledir . DIRECTORY_SEPARATOR . $destfilename;

if( !is_dir( $destfiledir ) ){
  $madedir = mkdir( $destfiledir, 0755, true );
  if( !$madedir ){
    trigger_error( "Upload directory could not be created. Please check file permissions of $destfiledir or its parents.", E_USER_ERROR );
  }
}

#move file to media storage area and give it the name obtained above

if( !move_uploaded_file( $tmpname, $destfilepath ) ){
  trigger_error( "Could not move file " . $tmpname . " to final " . $destfilename . ". Make sure you have enough free disk space.", E_USER_ERROR ); 
}

#Add it to the upload queue so that it gets uploaded by the rsync cron job

addtoqueue( XMLRPC_SERVER, "upload", $destfilename, $filetype, $fileoption );
addtoqueue( XMLRPC_SERVER, "transcode", $destfilename, $filetype, $fileoption );
echo '<?xml version="1.0" encoding="UTF-8"?>';
?>
<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
<key>success</key>
<true/>
</dict>
</plist>
