<?

/* This script handles files uploaded to the local servers.
   They are POSTed here from the isuma.tv site,
   whereupon they are renamed to a unique name asigned by the
   central server, and then added to this server's upload queue.
   */

include "../sync/transfer.inc";

$filetype = $_POST['filetype'];

$fileoption = $_POST['fileoption'];

$nid = $_POST['nid'];

/* Fill in the type and option fields with reasonable defaults
   for testing uploads
   We also use "raw" in produciton as the type for a newly uploaded video
   */

if( $filetype == "" ){
  $filetype = "video";
}
if( $fileoption =="" ){
  $fileoption = "raw";
}

  if( count(  $_FILES ) < 1 ){
    header( "Location: http://www.isuma.tv/local-server-error" );
    exit();
  }

#If we make it here, a file was uploaded. Get its new file name from the
#central server, and move it to that location.

#first, delete any unpublished files in file queue
#to pevent name collisions
deleteunpublished( XMLRPC_SERVER, ISUMA_ROOT . DIRECTORY_SEPARATOR . "media", "file" );

$origfilename = $_FILES['newmedia']['name'];

$tmpname =  $_FILES['newmedia']['tmp_name'];
if( !is_uploaded_file( $tmpname ) ){
  trigger_error( $tmpname . " is not a legitimate file upload. This access attempt has been logged." , E_USER_ERROR );
}


if( $_FILES['newmedia']['error'] != UPLOAD_ERR_OK ){
  trigger_error( "Upload failed with error code " . $_FILES['newmedia']['error'],  E_USER_ERROR );
}

#Get new filename from central server using reservefilename

$destfilename = reservefilename( XMLRPC_SERVER, $nid, $origfilename, $filetype, $fileoption );
$destfiledir = ISUMA_ROOT . DIRECTORY_SEPARATOR . "media" . DIRECTORY_SEPARATOR . $filetype . DIRECTORY_SEPARATOR . $fileoption;
$destfilepath = $destfiledir . DIRECTORY_SEPARATOR . $destfilename;

if( !is_dir( $destfiledir ) ){
  $madedir = mkdir( $destfiledir, 0755, true );
  if( !$madedir ){
    trigger_error( "Upload directory could not be created. Please check file permissions of $destfiledir or its parents.", E_USER_ERROR );
  }
}

#move file to media storage area and give it the name obtained above

if( !move_uploaded_file( $tmpname, $destfilepath ) ){
  trigger_error( "Could not move file " . $tmpname . " to final " . $destfilename . ". Make sure you have enough free disk space.", E_USER_ERROR ); 
}

#Add it to the upload queue so that it gets uploaded by the rsync cron job

addtoqueue( XMLRPC_SERVER, "upload", $destfilename, $filetype, $fileoption );
addtoqueue( XMLRPC_SERVER, "transcode", $destfilename, $filetype, $fileoption );

//If this variable is set, we are to redirect to this page after upload completes
if( $_POST['uploadcomplete'] ){
  header( "Location: http://" . $_POST['uploadcomplete'] );
}


function display_form(){
?>
  <html>
  <head>
  <title>Video Upload</title>
  </head>
  <body>
  <form enctype="multipart/form-data" action="upload.php" method="POST" >
  <input type = "hidden" name = "MAX_FILE_SIZE" value = "2147483648" />
  <input type = "text" name = "filetype" value = "<?print $filetype;?>" />
  <input type = "text" name = "fileoption" value = "<?print $fileoption;?>" />
  <input type = "text" name = "nid" value = "<?print $nid;?>" />
  <input type = "file" name = "newmedia" />
  <input type = "submit" value = "Upload Now!" />
  </form>

  <div>
<?
//print("Upload of " . $_FILES['newmedia']['name'] . " to " . $destfilename . " successful!");
?>
  </div>
  </body>
  </html>
<?
}
?>
